// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_actions_msgs:action/FaceOverlay.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__ACTION__DETAIL__FACE_OVERLAY__STRUCT_HPP_
#define HRI_ACTIONS_MSGS__ACTION__DETAIL__FACE_OVERLAY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_Goal __attribute__((deprecated))
#else
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_Goal __declspec(deprecated)
#endif

namespace hri_actions_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct FaceOverlay_Goal_
{
  using Type = FaceOverlay_Goal_<ContainerAllocator>;

  explicit FaceOverlay_Goal_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->media_url = "";
      this->duration = 0.0f;
      this->layer = 0;
      this->layout = 0;
      this->scale = 0.0f;
      this->offset_x = 0.0f;
      this->offset_y = 0.0f;
      this->fade = false;
    }
  }

  explicit FaceOverlay_Goal_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : media_url(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->media_url = "";
      this->duration = 0.0f;
      this->layer = 0;
      this->layout = 0;
      this->scale = 0.0f;
      this->offset_x = 0.0f;
      this->offset_y = 0.0f;
      this->fade = false;
    }
  }

  // field types and members
  using _media_url_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _media_url_type media_url;
  using _duration_type =
    float;
  _duration_type duration;
  using _layer_type =
    uint8_t;
  _layer_type layer;
  using _layout_type =
    uint8_t;
  _layout_type layout;
  using _scale_type =
    float;
  _scale_type scale;
  using _offset_x_type =
    float;
  _offset_x_type offset_x;
  using _offset_y_type =
    float;
  _offset_y_type offset_y;
  using _fade_type =
    bool;
  _fade_type fade;

  // setters for named parameter idiom
  Type & set__media_url(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->media_url = _arg;
    return *this;
  }
  Type & set__duration(
    const float & _arg)
  {
    this->duration = _arg;
    return *this;
  }
  Type & set__layer(
    const uint8_t & _arg)
  {
    this->layer = _arg;
    return *this;
  }
  Type & set__layout(
    const uint8_t & _arg)
  {
    this->layout = _arg;
    return *this;
  }
  Type & set__scale(
    const float & _arg)
  {
    this->scale = _arg;
    return *this;
  }
  Type & set__offset_x(
    const float & _arg)
  {
    this->offset_x = _arg;
    return *this;
  }
  Type & set__offset_y(
    const float & _arg)
  {
    this->offset_y = _arg;
    return *this;
  }
  Type & set__fade(
    const bool & _arg)
  {
    this->fade = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t BACKGROUND =
    0u;
  static constexpr uint8_t FOREGROUND =
    1u;
  static constexpr uint8_t EXTEND =
    0u;
  static constexpr uint8_t COPY =
    1u;
  static constexpr uint8_t MIRROR =
    2u;
  static constexpr uint8_t LEFT_EYE_ONLY =
    3u;
  static constexpr uint8_t RIGHT_EYE_ONLY =
    4u;

  // pointer types
  using RawPtr =
    hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_Goal
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_Goal
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FaceOverlay_Goal_ & other) const
  {
    if (this->media_url != other.media_url) {
      return false;
    }
    if (this->duration != other.duration) {
      return false;
    }
    if (this->layer != other.layer) {
      return false;
    }
    if (this->layout != other.layout) {
      return false;
    }
    if (this->scale != other.scale) {
      return false;
    }
    if (this->offset_x != other.offset_x) {
      return false;
    }
    if (this->offset_y != other.offset_y) {
      return false;
    }
    if (this->fade != other.fade) {
      return false;
    }
    return true;
  }
  bool operator!=(const FaceOverlay_Goal_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FaceOverlay_Goal_

// alias to use template instance with default allocator
using FaceOverlay_Goal =
  hri_actions_msgs::action::FaceOverlay_Goal_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FaceOverlay_Goal_<ContainerAllocator>::BACKGROUND;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FaceOverlay_Goal_<ContainerAllocator>::FOREGROUND;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FaceOverlay_Goal_<ContainerAllocator>::EXTEND;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FaceOverlay_Goal_<ContainerAllocator>::COPY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FaceOverlay_Goal_<ContainerAllocator>::MIRROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FaceOverlay_Goal_<ContainerAllocator>::LEFT_EYE_ONLY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FaceOverlay_Goal_<ContainerAllocator>::RIGHT_EYE_ONLY;
#endif  // __cplusplus < 201703L

}  // namespace action

}  // namespace hri_actions_msgs


#ifndef _WIN32
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_Result __attribute__((deprecated))
#else
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_Result __declspec(deprecated)
#endif

namespace hri_actions_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct FaceOverlay_Result_
{
  using Type = FaceOverlay_Result_<ContainerAllocator>;

  explicit FaceOverlay_Result_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit FaceOverlay_Result_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_Result
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_Result
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FaceOverlay_Result_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const FaceOverlay_Result_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FaceOverlay_Result_

// alias to use template instance with default allocator
using FaceOverlay_Result =
  hri_actions_msgs::action::FaceOverlay_Result_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace hri_actions_msgs


#ifndef _WIN32
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_Feedback __attribute__((deprecated))
#else
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_Feedback __declspec(deprecated)
#endif

namespace hri_actions_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct FaceOverlay_Feedback_
{
  using Type = FaceOverlay_Feedback_<ContainerAllocator>;

  explicit FaceOverlay_Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit FaceOverlay_Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_Feedback
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_Feedback
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FaceOverlay_Feedback_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const FaceOverlay_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FaceOverlay_Feedback_

// alias to use template instance with default allocator
using FaceOverlay_Feedback =
  hri_actions_msgs::action::FaceOverlay_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace hri_actions_msgs


// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'goal'
#include "hri_actions_msgs/action/detail/face_overlay__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_SendGoal_Request __attribute__((deprecated))
#else
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_SendGoal_Request __declspec(deprecated)
#endif

namespace hri_actions_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct FaceOverlay_SendGoal_Request_
{
  using Type = FaceOverlay_SendGoal_Request_<ContainerAllocator>;

  explicit FaceOverlay_SendGoal_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    goal(_init)
  {
    (void)_init;
  }

  explicit FaceOverlay_SendGoal_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    goal(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _goal_type =
    hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator>;
  _goal_type goal;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__goal(
    const hri_actions_msgs::action::FaceOverlay_Goal_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_SendGoal_Request
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_SendGoal_Request
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FaceOverlay_SendGoal_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const FaceOverlay_SendGoal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FaceOverlay_SendGoal_Request_

// alias to use template instance with default allocator
using FaceOverlay_SendGoal_Request =
  hri_actions_msgs::action::FaceOverlay_SendGoal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace hri_actions_msgs


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_SendGoal_Response __attribute__((deprecated))
#else
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_SendGoal_Response __declspec(deprecated)
#endif

namespace hri_actions_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct FaceOverlay_SendGoal_Response_
{
  using Type = FaceOverlay_SendGoal_Response_<ContainerAllocator>;

  explicit FaceOverlay_SendGoal_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  explicit FaceOverlay_SendGoal_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  // field types and members
  using _accepted_type =
    bool;
  _accepted_type accepted;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__accepted(
    const bool & _arg)
  {
    this->accepted = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_SendGoal_Response
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_SendGoal_Response
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FaceOverlay_SendGoal_Response_ & other) const
  {
    if (this->accepted != other.accepted) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const FaceOverlay_SendGoal_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FaceOverlay_SendGoal_Response_

// alias to use template instance with default allocator
using FaceOverlay_SendGoal_Response =
  hri_actions_msgs::action::FaceOverlay_SendGoal_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace hri_actions_msgs

namespace hri_actions_msgs
{

namespace action
{

struct FaceOverlay_SendGoal
{
  using Request = hri_actions_msgs::action::FaceOverlay_SendGoal_Request;
  using Response = hri_actions_msgs::action::FaceOverlay_SendGoal_Response;
};

}  // namespace action

}  // namespace hri_actions_msgs


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_GetResult_Request __attribute__((deprecated))
#else
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_GetResult_Request __declspec(deprecated)
#endif

namespace hri_actions_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct FaceOverlay_GetResult_Request_
{
  using Type = FaceOverlay_GetResult_Request_<ContainerAllocator>;

  explicit FaceOverlay_GetResult_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init)
  {
    (void)_init;
  }

  explicit FaceOverlay_GetResult_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hri_actions_msgs::action::FaceOverlay_GetResult_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_actions_msgs::action::FaceOverlay_GetResult_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_GetResult_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_GetResult_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_GetResult_Request
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_GetResult_Request
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FaceOverlay_GetResult_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const FaceOverlay_GetResult_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FaceOverlay_GetResult_Request_

// alias to use template instance with default allocator
using FaceOverlay_GetResult_Request =
  hri_actions_msgs::action::FaceOverlay_GetResult_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace hri_actions_msgs


// Include directives for member types
// Member 'result'
// already included above
// #include "hri_actions_msgs/action/detail/face_overlay__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_GetResult_Response __attribute__((deprecated))
#else
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_GetResult_Response __declspec(deprecated)
#endif

namespace hri_actions_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct FaceOverlay_GetResult_Response_
{
  using Type = FaceOverlay_GetResult_Response_<ContainerAllocator>;

  explicit FaceOverlay_GetResult_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit FaceOverlay_GetResult_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    int8_t;
  _status_type status;
  using _result_type =
    hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__result(
    const hri_actions_msgs::action::FaceOverlay_Result_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hri_actions_msgs::action::FaceOverlay_GetResult_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_actions_msgs::action::FaceOverlay_GetResult_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_GetResult_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_GetResult_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_GetResult_Response
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_GetResult_Response
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_GetResult_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FaceOverlay_GetResult_Response_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const FaceOverlay_GetResult_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FaceOverlay_GetResult_Response_

// alias to use template instance with default allocator
using FaceOverlay_GetResult_Response =
  hri_actions_msgs::action::FaceOverlay_GetResult_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace hri_actions_msgs

namespace hri_actions_msgs
{

namespace action
{

struct FaceOverlay_GetResult
{
  using Request = hri_actions_msgs::action::FaceOverlay_GetResult_Request;
  using Response = hri_actions_msgs::action::FaceOverlay_GetResult_Response;
};

}  // namespace action

}  // namespace hri_actions_msgs


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'feedback'
// already included above
// #include "hri_actions_msgs/action/detail/face_overlay__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_FeedbackMessage __attribute__((deprecated))
#else
# define DEPRECATED__hri_actions_msgs__action__FaceOverlay_FeedbackMessage __declspec(deprecated)
#endif

namespace hri_actions_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct FaceOverlay_FeedbackMessage_
{
  using Type = FaceOverlay_FeedbackMessage_<ContainerAllocator>;

  explicit FaceOverlay_FeedbackMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    feedback(_init)
  {
    (void)_init;
  }

  explicit FaceOverlay_FeedbackMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    feedback(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _feedback_type =
    hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator>;
  _feedback_type feedback;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__feedback(
    const hri_actions_msgs::action::FaceOverlay_Feedback_<ContainerAllocator> & _arg)
  {
    this->feedback = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_FeedbackMessage
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_actions_msgs__action__FaceOverlay_FeedbackMessage
    std::shared_ptr<hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FaceOverlay_FeedbackMessage_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->feedback != other.feedback) {
      return false;
    }
    return true;
  }
  bool operator!=(const FaceOverlay_FeedbackMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FaceOverlay_FeedbackMessage_

// alias to use template instance with default allocator
using FaceOverlay_FeedbackMessage =
  hri_actions_msgs::action::FaceOverlay_FeedbackMessage_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace hri_actions_msgs

#include "action_msgs/srv/cancel_goal.hpp"
#include "action_msgs/msg/goal_info.hpp"
#include "action_msgs/msg/goal_status_array.hpp"

namespace hri_actions_msgs
{

namespace action
{

struct FaceOverlay
{
  /// The goal message defined in the action definition.
  using Goal = hri_actions_msgs::action::FaceOverlay_Goal;
  /// The result message defined in the action definition.
  using Result = hri_actions_msgs::action::FaceOverlay_Result;
  /// The feedback message defined in the action definition.
  using Feedback = hri_actions_msgs::action::FaceOverlay_Feedback;

  struct Impl
  {
    /// The send_goal service using a wrapped version of the goal message as a request.
    using SendGoalService = hri_actions_msgs::action::FaceOverlay_SendGoal;
    /// The get_result service using a wrapped version of the result message as a response.
    using GetResultService = hri_actions_msgs::action::FaceOverlay_GetResult;
    /// The feedback message with generic fields which wraps the feedback message.
    using FeedbackMessage = hri_actions_msgs::action::FaceOverlay_FeedbackMessage;

    /// The generic service to cancel a goal.
    using CancelGoalService = action_msgs::srv::CancelGoal;
    /// The generic message for the status of a goal.
    using GoalStatusMessage = action_msgs::msg::GoalStatusArray;
  };
};

typedef struct FaceOverlay FaceOverlay;

}  // namespace action

}  // namespace hri_actions_msgs

#endif  // HRI_ACTIONS_MSGS__ACTION__DETAIL__FACE_OVERLAY__STRUCT_HPP_
