// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from hri_actions_msgs:action/LookAt.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__ACTION__DETAIL__LOOK_AT__FUNCTIONS_H_
#define HRI_ACTIONS_MSGS__ACTION__DETAIL__LOOK_AT__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "hri_actions_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "hri_actions_msgs/action/detail/look_at__struct.h"

/// Initialize action/LookAt message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * hri_actions_msgs__action__LookAt_Goal
 * )) before or use
 * hri_actions_msgs__action__LookAt_Goal__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Goal__init(hri_actions_msgs__action__LookAt_Goal * msg);

/// Finalize action/LookAt message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_Goal__fini(hri_actions_msgs__action__LookAt_Goal * msg);

/// Create action/LookAt message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * hri_actions_msgs__action__LookAt_Goal__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_Goal *
hri_actions_msgs__action__LookAt_Goal__create();

/// Destroy action/LookAt message.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_Goal__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_Goal__destroy(hri_actions_msgs__action__LookAt_Goal * msg);

/// Check for action/LookAt message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Goal__are_equal(const hri_actions_msgs__action__LookAt_Goal * lhs, const hri_actions_msgs__action__LookAt_Goal * rhs);

/// Copy a action/LookAt message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Goal__copy(
  const hri_actions_msgs__action__LookAt_Goal * input,
  hri_actions_msgs__action__LookAt_Goal * output);

/// Initialize array of action/LookAt messages.
/**
 * It allocates the memory for the number of elements and calls
 * hri_actions_msgs__action__LookAt_Goal__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Goal__Sequence__init(hri_actions_msgs__action__LookAt_Goal__Sequence * array, size_t size);

/// Finalize array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_Goal__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_Goal__Sequence__fini(hri_actions_msgs__action__LookAt_Goal__Sequence * array);

/// Create array of action/LookAt messages.
/**
 * It allocates the memory for the array and calls
 * hri_actions_msgs__action__LookAt_Goal__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_Goal__Sequence *
hri_actions_msgs__action__LookAt_Goal__Sequence__create(size_t size);

/// Destroy array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_Goal__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_Goal__Sequence__destroy(hri_actions_msgs__action__LookAt_Goal__Sequence * array);

/// Check for action/LookAt message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Goal__Sequence__are_equal(const hri_actions_msgs__action__LookAt_Goal__Sequence * lhs, const hri_actions_msgs__action__LookAt_Goal__Sequence * rhs);

/// Copy an array of action/LookAt messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Goal__Sequence__copy(
  const hri_actions_msgs__action__LookAt_Goal__Sequence * input,
  hri_actions_msgs__action__LookAt_Goal__Sequence * output);

/// Initialize action/LookAt message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * hri_actions_msgs__action__LookAt_Result
 * )) before or use
 * hri_actions_msgs__action__LookAt_Result__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Result__init(hri_actions_msgs__action__LookAt_Result * msg);

/// Finalize action/LookAt message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_Result__fini(hri_actions_msgs__action__LookAt_Result * msg);

/// Create action/LookAt message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * hri_actions_msgs__action__LookAt_Result__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_Result *
hri_actions_msgs__action__LookAt_Result__create();

/// Destroy action/LookAt message.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_Result__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_Result__destroy(hri_actions_msgs__action__LookAt_Result * msg);

/// Check for action/LookAt message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Result__are_equal(const hri_actions_msgs__action__LookAt_Result * lhs, const hri_actions_msgs__action__LookAt_Result * rhs);

/// Copy a action/LookAt message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Result__copy(
  const hri_actions_msgs__action__LookAt_Result * input,
  hri_actions_msgs__action__LookAt_Result * output);

/// Initialize array of action/LookAt messages.
/**
 * It allocates the memory for the number of elements and calls
 * hri_actions_msgs__action__LookAt_Result__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Result__Sequence__init(hri_actions_msgs__action__LookAt_Result__Sequence * array, size_t size);

/// Finalize array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_Result__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_Result__Sequence__fini(hri_actions_msgs__action__LookAt_Result__Sequence * array);

/// Create array of action/LookAt messages.
/**
 * It allocates the memory for the array and calls
 * hri_actions_msgs__action__LookAt_Result__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_Result__Sequence *
hri_actions_msgs__action__LookAt_Result__Sequence__create(size_t size);

/// Destroy array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_Result__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_Result__Sequence__destroy(hri_actions_msgs__action__LookAt_Result__Sequence * array);

/// Check for action/LookAt message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Result__Sequence__are_equal(const hri_actions_msgs__action__LookAt_Result__Sequence * lhs, const hri_actions_msgs__action__LookAt_Result__Sequence * rhs);

/// Copy an array of action/LookAt messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Result__Sequence__copy(
  const hri_actions_msgs__action__LookAt_Result__Sequence * input,
  hri_actions_msgs__action__LookAt_Result__Sequence * output);

/// Initialize action/LookAt message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * hri_actions_msgs__action__LookAt_Feedback
 * )) before or use
 * hri_actions_msgs__action__LookAt_Feedback__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Feedback__init(hri_actions_msgs__action__LookAt_Feedback * msg);

/// Finalize action/LookAt message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_Feedback__fini(hri_actions_msgs__action__LookAt_Feedback * msg);

/// Create action/LookAt message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * hri_actions_msgs__action__LookAt_Feedback__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_Feedback *
hri_actions_msgs__action__LookAt_Feedback__create();

/// Destroy action/LookAt message.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_Feedback__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_Feedback__destroy(hri_actions_msgs__action__LookAt_Feedback * msg);

/// Check for action/LookAt message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Feedback__are_equal(const hri_actions_msgs__action__LookAt_Feedback * lhs, const hri_actions_msgs__action__LookAt_Feedback * rhs);

/// Copy a action/LookAt message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Feedback__copy(
  const hri_actions_msgs__action__LookAt_Feedback * input,
  hri_actions_msgs__action__LookAt_Feedback * output);

/// Initialize array of action/LookAt messages.
/**
 * It allocates the memory for the number of elements and calls
 * hri_actions_msgs__action__LookAt_Feedback__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Feedback__Sequence__init(hri_actions_msgs__action__LookAt_Feedback__Sequence * array, size_t size);

/// Finalize array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_Feedback__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_Feedback__Sequence__fini(hri_actions_msgs__action__LookAt_Feedback__Sequence * array);

/// Create array of action/LookAt messages.
/**
 * It allocates the memory for the array and calls
 * hri_actions_msgs__action__LookAt_Feedback__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_Feedback__Sequence *
hri_actions_msgs__action__LookAt_Feedback__Sequence__create(size_t size);

/// Destroy array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_Feedback__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_Feedback__Sequence__destroy(hri_actions_msgs__action__LookAt_Feedback__Sequence * array);

/// Check for action/LookAt message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Feedback__Sequence__are_equal(const hri_actions_msgs__action__LookAt_Feedback__Sequence * lhs, const hri_actions_msgs__action__LookAt_Feedback__Sequence * rhs);

/// Copy an array of action/LookAt messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_Feedback__Sequence__copy(
  const hri_actions_msgs__action__LookAt_Feedback__Sequence * input,
  hri_actions_msgs__action__LookAt_Feedback__Sequence * output);

/// Initialize action/LookAt message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * hri_actions_msgs__action__LookAt_SendGoal_Request
 * )) before or use
 * hri_actions_msgs__action__LookAt_SendGoal_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_SendGoal_Request__init(hri_actions_msgs__action__LookAt_SendGoal_Request * msg);

/// Finalize action/LookAt message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_SendGoal_Request__fini(hri_actions_msgs__action__LookAt_SendGoal_Request * msg);

/// Create action/LookAt message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * hri_actions_msgs__action__LookAt_SendGoal_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_SendGoal_Request *
hri_actions_msgs__action__LookAt_SendGoal_Request__create();

/// Destroy action/LookAt message.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_SendGoal_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_SendGoal_Request__destroy(hri_actions_msgs__action__LookAt_SendGoal_Request * msg);

/// Check for action/LookAt message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_SendGoal_Request__are_equal(const hri_actions_msgs__action__LookAt_SendGoal_Request * lhs, const hri_actions_msgs__action__LookAt_SendGoal_Request * rhs);

/// Copy a action/LookAt message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_SendGoal_Request__copy(
  const hri_actions_msgs__action__LookAt_SendGoal_Request * input,
  hri_actions_msgs__action__LookAt_SendGoal_Request * output);

/// Initialize array of action/LookAt messages.
/**
 * It allocates the memory for the number of elements and calls
 * hri_actions_msgs__action__LookAt_SendGoal_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__init(hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * array, size_t size);

/// Finalize array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_SendGoal_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__fini(hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * array);

/// Create array of action/LookAt messages.
/**
 * It allocates the memory for the array and calls
 * hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence *
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__create(size_t size);

/// Destroy array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__destroy(hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * array);

/// Check for action/LookAt message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__are_equal(const hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * lhs, const hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * rhs);

/// Copy an array of action/LookAt messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence__copy(
  const hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * input,
  hri_actions_msgs__action__LookAt_SendGoal_Request__Sequence * output);

/// Initialize action/LookAt message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * hri_actions_msgs__action__LookAt_SendGoal_Response
 * )) before or use
 * hri_actions_msgs__action__LookAt_SendGoal_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_SendGoal_Response__init(hri_actions_msgs__action__LookAt_SendGoal_Response * msg);

/// Finalize action/LookAt message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_SendGoal_Response__fini(hri_actions_msgs__action__LookAt_SendGoal_Response * msg);

/// Create action/LookAt message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * hri_actions_msgs__action__LookAt_SendGoal_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_SendGoal_Response *
hri_actions_msgs__action__LookAt_SendGoal_Response__create();

/// Destroy action/LookAt message.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_SendGoal_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_SendGoal_Response__destroy(hri_actions_msgs__action__LookAt_SendGoal_Response * msg);

/// Check for action/LookAt message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_SendGoal_Response__are_equal(const hri_actions_msgs__action__LookAt_SendGoal_Response * lhs, const hri_actions_msgs__action__LookAt_SendGoal_Response * rhs);

/// Copy a action/LookAt message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_SendGoal_Response__copy(
  const hri_actions_msgs__action__LookAt_SendGoal_Response * input,
  hri_actions_msgs__action__LookAt_SendGoal_Response * output);

/// Initialize array of action/LookAt messages.
/**
 * It allocates the memory for the number of elements and calls
 * hri_actions_msgs__action__LookAt_SendGoal_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__init(hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * array, size_t size);

/// Finalize array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_SendGoal_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__fini(hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * array);

/// Create array of action/LookAt messages.
/**
 * It allocates the memory for the array and calls
 * hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence *
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__create(size_t size);

/// Destroy array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__destroy(hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * array);

/// Check for action/LookAt message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__are_equal(const hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * lhs, const hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * rhs);

/// Copy an array of action/LookAt messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence__copy(
  const hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * input,
  hri_actions_msgs__action__LookAt_SendGoal_Response__Sequence * output);

/// Initialize action/LookAt message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * hri_actions_msgs__action__LookAt_GetResult_Request
 * )) before or use
 * hri_actions_msgs__action__LookAt_GetResult_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_GetResult_Request__init(hri_actions_msgs__action__LookAt_GetResult_Request * msg);

/// Finalize action/LookAt message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_GetResult_Request__fini(hri_actions_msgs__action__LookAt_GetResult_Request * msg);

/// Create action/LookAt message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * hri_actions_msgs__action__LookAt_GetResult_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_GetResult_Request *
hri_actions_msgs__action__LookAt_GetResult_Request__create();

/// Destroy action/LookAt message.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_GetResult_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_GetResult_Request__destroy(hri_actions_msgs__action__LookAt_GetResult_Request * msg);

/// Check for action/LookAt message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_GetResult_Request__are_equal(const hri_actions_msgs__action__LookAt_GetResult_Request * lhs, const hri_actions_msgs__action__LookAt_GetResult_Request * rhs);

/// Copy a action/LookAt message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_GetResult_Request__copy(
  const hri_actions_msgs__action__LookAt_GetResult_Request * input,
  hri_actions_msgs__action__LookAt_GetResult_Request * output);

/// Initialize array of action/LookAt messages.
/**
 * It allocates the memory for the number of elements and calls
 * hri_actions_msgs__action__LookAt_GetResult_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__init(hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * array, size_t size);

/// Finalize array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_GetResult_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__fini(hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * array);

/// Create array of action/LookAt messages.
/**
 * It allocates the memory for the array and calls
 * hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence *
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__create(size_t size);

/// Destroy array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__destroy(hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * array);

/// Check for action/LookAt message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__are_equal(const hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * lhs, const hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * rhs);

/// Copy an array of action/LookAt messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_GetResult_Request__Sequence__copy(
  const hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * input,
  hri_actions_msgs__action__LookAt_GetResult_Request__Sequence * output);

/// Initialize action/LookAt message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * hri_actions_msgs__action__LookAt_GetResult_Response
 * )) before or use
 * hri_actions_msgs__action__LookAt_GetResult_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_GetResult_Response__init(hri_actions_msgs__action__LookAt_GetResult_Response * msg);

/// Finalize action/LookAt message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_GetResult_Response__fini(hri_actions_msgs__action__LookAt_GetResult_Response * msg);

/// Create action/LookAt message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * hri_actions_msgs__action__LookAt_GetResult_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_GetResult_Response *
hri_actions_msgs__action__LookAt_GetResult_Response__create();

/// Destroy action/LookAt message.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_GetResult_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_GetResult_Response__destroy(hri_actions_msgs__action__LookAt_GetResult_Response * msg);

/// Check for action/LookAt message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_GetResult_Response__are_equal(const hri_actions_msgs__action__LookAt_GetResult_Response * lhs, const hri_actions_msgs__action__LookAt_GetResult_Response * rhs);

/// Copy a action/LookAt message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_GetResult_Response__copy(
  const hri_actions_msgs__action__LookAt_GetResult_Response * input,
  hri_actions_msgs__action__LookAt_GetResult_Response * output);

/// Initialize array of action/LookAt messages.
/**
 * It allocates the memory for the number of elements and calls
 * hri_actions_msgs__action__LookAt_GetResult_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__init(hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * array, size_t size);

/// Finalize array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_GetResult_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__fini(hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * array);

/// Create array of action/LookAt messages.
/**
 * It allocates the memory for the array and calls
 * hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence *
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__create(size_t size);

/// Destroy array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__destroy(hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * array);

/// Check for action/LookAt message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__are_equal(const hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * lhs, const hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * rhs);

/// Copy an array of action/LookAt messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_GetResult_Response__Sequence__copy(
  const hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * input,
  hri_actions_msgs__action__LookAt_GetResult_Response__Sequence * output);

/// Initialize action/LookAt message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * hri_actions_msgs__action__LookAt_FeedbackMessage
 * )) before or use
 * hri_actions_msgs__action__LookAt_FeedbackMessage__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_FeedbackMessage__init(hri_actions_msgs__action__LookAt_FeedbackMessage * msg);

/// Finalize action/LookAt message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_FeedbackMessage__fini(hri_actions_msgs__action__LookAt_FeedbackMessage * msg);

/// Create action/LookAt message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * hri_actions_msgs__action__LookAt_FeedbackMessage__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_FeedbackMessage *
hri_actions_msgs__action__LookAt_FeedbackMessage__create();

/// Destroy action/LookAt message.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_FeedbackMessage__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_FeedbackMessage__destroy(hri_actions_msgs__action__LookAt_FeedbackMessage * msg);

/// Check for action/LookAt message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_FeedbackMessage__are_equal(const hri_actions_msgs__action__LookAt_FeedbackMessage * lhs, const hri_actions_msgs__action__LookAt_FeedbackMessage * rhs);

/// Copy a action/LookAt message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_FeedbackMessage__copy(
  const hri_actions_msgs__action__LookAt_FeedbackMessage * input,
  hri_actions_msgs__action__LookAt_FeedbackMessage * output);

/// Initialize array of action/LookAt messages.
/**
 * It allocates the memory for the number of elements and calls
 * hri_actions_msgs__action__LookAt_FeedbackMessage__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__init(hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * array, size_t size);

/// Finalize array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_FeedbackMessage__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__fini(hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * array);

/// Create array of action/LookAt messages.
/**
 * It allocates the memory for the array and calls
 * hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence *
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__create(size_t size);

/// Destroy array of action/LookAt messages.
/**
 * It calls
 * hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
void
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__destroy(hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * array);

/// Check for action/LookAt message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__are_equal(const hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * lhs, const hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * rhs);

/// Copy an array of action/LookAt messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_hri_actions_msgs
bool
hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence__copy(
  const hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * input,
  hri_actions_msgs__action__LookAt_FeedbackMessage__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // HRI_ACTIONS_MSGS__ACTION__DETAIL__LOOK_AT__FUNCTIONS_H_
