// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_actions_msgs:msg/Intent.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__MSG__DETAIL__INTENT__STRUCT_HPP_
#define HRI_ACTIONS_MSGS__MSG__DETAIL__INTENT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__hri_actions_msgs__msg__Intent __attribute__((deprecated))
#else
# define DEPRECATED__hri_actions_msgs__msg__Intent __declspec(deprecated)
#endif

namespace hri_actions_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Intent_
{
  using Type = Intent_<ContainerAllocator>;

  explicit Intent_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->intent = "";
      this->data = "";
      this->source = "";
      this->modality = "";
      this->priority = 0;
      this->confidence = 0.0f;
    }
  }

  explicit Intent_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : intent(_alloc),
    data(_alloc),
    source(_alloc),
    modality(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->intent = "";
      this->data = "";
      this->source = "";
      this->modality = "";
      this->priority = 0;
      this->confidence = 0.0f;
    }
  }

  // field types and members
  using _intent_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _intent_type intent;
  using _data_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _data_type data;
  using _source_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _source_type source;
  using _modality_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _modality_type modality;
  using _priority_type =
    uint8_t;
  _priority_type priority;
  using _confidence_type =
    float;
  _confidence_type confidence;

  // setters for named parameter idiom
  Type & set__intent(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->intent = _arg;
    return *this;
  }
  Type & set__data(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->data = _arg;
    return *this;
  }
  Type & set__source(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->source = _arg;
    return *this;
  }
  Type & set__modality(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->modality = _arg;
    return *this;
  }
  Type & set__priority(
    const uint8_t & _arg)
  {
    this->priority = _arg;
    return *this;
  }
  Type & set__confidence(
    const float & _arg)
  {
    this->confidence = _arg;
    return *this;
  }

  // constant declarations
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> ENGAGE_WITH;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> MOVE_TO;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> GUIDE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> GRAB_OBJECT;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> BRING_OBJECT;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> PLACE_OBJECT;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> GREET;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> SAY;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> PRESENT_CONTENT;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> PERFORM_MOTION;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> START_ACTIVITY;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STOP_ACTIVITY;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> WAKEUP;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> SUSPEND;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> ROBOT_ITSELF;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> REMOTE_SUPERVISOR;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> UNKNOWN_AGENT;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> UNKNOWN;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> MODALITY_SPEECH;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> MODALITY_MOTION;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> MODALITY_TOUCHSCREEN;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> MODALITY_OTHER;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> MODALITY_INTERNAL;

  // pointer types
  using RawPtr =
    hri_actions_msgs::msg::Intent_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_actions_msgs::msg::Intent_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_actions_msgs::msg::Intent_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_actions_msgs::msg::Intent_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::msg::Intent_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::msg::Intent_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::msg::Intent_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::msg::Intent_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_actions_msgs::msg::Intent_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_actions_msgs::msg::Intent_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_actions_msgs__msg__Intent
    std::shared_ptr<hri_actions_msgs::msg::Intent_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_actions_msgs__msg__Intent
    std::shared_ptr<hri_actions_msgs::msg::Intent_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Intent_ & other) const
  {
    if (this->intent != other.intent) {
      return false;
    }
    if (this->data != other.data) {
      return false;
    }
    if (this->source != other.source) {
      return false;
    }
    if (this->modality != other.modality) {
      return false;
    }
    if (this->priority != other.priority) {
      return false;
    }
    if (this->confidence != other.confidence) {
      return false;
    }
    return true;
  }
  bool operator!=(const Intent_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Intent_

// alias to use template instance with default allocator
using Intent =
  hri_actions_msgs::msg::Intent_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::ENGAGE_WITH = "__intent_engage_with__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::MOVE_TO = "__intent_move_to__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::GUIDE = "__intent_guide__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::GRAB_OBJECT = "__intent_grab_object__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::BRING_OBJECT = "__intent_bring_object__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::PLACE_OBJECT = "__intent_place_object__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::GREET = "__intent_greet__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::SAY = "__intent_say__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::PRESENT_CONTENT = "__intent_present_content__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::PERFORM_MOTION = "__intent_perform_motion__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::START_ACTIVITY = "__intent_start_activity__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::STOP_ACTIVITY = "__intent_stop_activity__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::WAKEUP = "__intent_wakeup__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::SUSPEND = "__intent_suspend__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::ROBOT_ITSELF = "__myself__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::REMOTE_SUPERVISOR = "__remote_supervisor__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::UNKNOWN_AGENT = "__unknown_agent__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::UNKNOWN = "__unknown__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::MODALITY_SPEECH = "__modality_speech__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::MODALITY_MOTION = "__modality_motion__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::MODALITY_TOUCHSCREEN = "__modality_touchscreen__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::MODALITY_OTHER = "__modality_other__";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Intent_<ContainerAllocator>::MODALITY_INTERNAL = "__modality_internal__";

}  // namespace msg

}  // namespace hri_actions_msgs

#endif  // HRI_ACTIONS_MSGS__MSG__DETAIL__INTENT__STRUCT_HPP_
