// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hri_actions_msgs:msg/Intent.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__MSG__DETAIL__INTENT__TRAITS_HPP_
#define HRI_ACTIONS_MSGS__MSG__DETAIL__INTENT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hri_actions_msgs/msg/detail/intent__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace hri_actions_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Intent & msg,
  std::ostream & out)
{
  out << "{";
  // member: intent
  {
    out << "intent: ";
    rosidl_generator_traits::value_to_yaml(msg.intent, out);
    out << ", ";
  }

  // member: data
  {
    out << "data: ";
    rosidl_generator_traits::value_to_yaml(msg.data, out);
    out << ", ";
  }

  // member: source
  {
    out << "source: ";
    rosidl_generator_traits::value_to_yaml(msg.source, out);
    out << ", ";
  }

  // member: modality
  {
    out << "modality: ";
    rosidl_generator_traits::value_to_yaml(msg.modality, out);
    out << ", ";
  }

  // member: priority
  {
    out << "priority: ";
    rosidl_generator_traits::value_to_yaml(msg.priority, out);
    out << ", ";
  }

  // member: confidence
  {
    out << "confidence: ";
    rosidl_generator_traits::value_to_yaml(msg.confidence, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Intent & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: intent
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "intent: ";
    rosidl_generator_traits::value_to_yaml(msg.intent, out);
    out << "\n";
  }

  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data: ";
    rosidl_generator_traits::value_to_yaml(msg.data, out);
    out << "\n";
  }

  // member: source
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "source: ";
    rosidl_generator_traits::value_to_yaml(msg.source, out);
    out << "\n";
  }

  // member: modality
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "modality: ";
    rosidl_generator_traits::value_to_yaml(msg.modality, out);
    out << "\n";
  }

  // member: priority
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "priority: ";
    rosidl_generator_traits::value_to_yaml(msg.priority, out);
    out << "\n";
  }

  // member: confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "confidence: ";
    rosidl_generator_traits::value_to_yaml(msg.confidence, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Intent & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hri_actions_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hri_actions_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hri_actions_msgs::msg::Intent & msg,
  std::ostream & out, size_t indentation = 0)
{
  hri_actions_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hri_actions_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hri_actions_msgs::msg::Intent & msg)
{
  return hri_actions_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hri_actions_msgs::msg::Intent>()
{
  return "hri_actions_msgs::msg::Intent";
}

template<>
inline const char * name<hri_actions_msgs::msg::Intent>()
{
  return "hri_actions_msgs/msg/Intent";
}

template<>
struct has_fixed_size<hri_actions_msgs::msg::Intent>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<hri_actions_msgs::msg::Intent>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<hri_actions_msgs::msg::Intent>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HRI_ACTIONS_MSGS__MSG__DETAIL__INTENT__TRAITS_HPP_
