// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_actions_msgs:msg/ClosedCaption.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__MSG__DETAIL__CLOSED_CAPTION__STRUCT_H_
#define HRI_ACTIONS_MSGS__MSG__DETAIL__CLOSED_CAPTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SPEAKER_ID_SYSTEM'.
static const char * const hri_actions_msgs__msg__ClosedCaption__SPEAKER_ID_SYSTEM = "__system__";

/// Constant 'SPEAKER_ID_UNKNOWN'.
static const char * const hri_actions_msgs__msg__ClosedCaption__SPEAKER_ID_UNKNOWN = "__unknown__";

// Include directives for member types
// Member 'speaker_id'
// Member 'text'
// Member 'locale'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/ClosedCaption in the package hri_actions_msgs.
/**
  * The ID of the speaker who is uttering the text.
  * If the speaker is the system, the ID is SPEAKER_ID_SYSTEM.
  * An empty speaker_id is equivalent to setting it to SPEAKER_ID_UNKNOWN
 */
typedef struct hri_actions_msgs__msg__ClosedCaption
{
  rosidl_runtime_c__String speaker_id;
  /// The text which is being spoken.
  rosidl_runtime_c__String text;
  /// The localei of the caption, using following format:
  /// the [ISO 639-1 language code](https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes),
  /// lower case, followed by an underscore,
  /// followed by the [ISO 3166-1 alpha-2 region code](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2),
  /// upper case.
  ///
  /// For example, 'en_GB' specifies British English.
  rosidl_runtime_c__String locale;
} hri_actions_msgs__msg__ClosedCaption;

// Struct for a sequence of hri_actions_msgs__msg__ClosedCaption.
typedef struct hri_actions_msgs__msg__ClosedCaption__Sequence
{
  hri_actions_msgs__msg__ClosedCaption * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__msg__ClosedCaption__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_ACTIONS_MSGS__MSG__DETAIL__CLOSED_CAPTION__STRUCT_H_
