// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hri_actions_msgs:msg/LookAtWithStyle.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__MSG__DETAIL__LOOK_AT_WITH_STYLE__STRUCT_HPP_
#define HRI_ACTIONS_MSGS__MSG__DETAIL__LOOK_AT_WITH_STYLE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'target'
#include "geometry_msgs/msg/detail/point_stamped__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hri_actions_msgs__msg__LookAtWithStyle __attribute__((deprecated))
#else
# define DEPRECATED__hri_actions_msgs__msg__LookAtWithStyle __declspec(deprecated)
#endif

namespace hri_actions_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LookAtWithStyle_
{
  using Type = LookAtWithStyle_<ContainerAllocator>;

  explicit LookAtWithStyle_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : target(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->style = 0;
    }
  }

  explicit LookAtWithStyle_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : target(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->style = 0;
    }
  }

  // field types and members
  using _style_type =
    int8_t;
  _style_type style;
  using _target_type =
    geometry_msgs::msg::PointStamped_<ContainerAllocator>;
  _target_type target;

  // setters for named parameter idiom
  Type & set__style(
    const int8_t & _arg)
  {
    this->style = _arg;
    return *this;
  }
  Type & set__target(
    const geometry_msgs::msg::PointStamped_<ContainerAllocator> & _arg)
  {
    this->target = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int8_t DEFAULT =
    0;
  static constexpr int8_t EYES_ONLY =
    1;
  static constexpr int8_t HEAD_ONLY =
    2;

  // pointer types
  using RawPtr =
    hri_actions_msgs::msg::LookAtWithStyle_<ContainerAllocator> *;
  using ConstRawPtr =
    const hri_actions_msgs::msg::LookAtWithStyle_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hri_actions_msgs::msg::LookAtWithStyle_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hri_actions_msgs::msg::LookAtWithStyle_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::msg::LookAtWithStyle_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::msg::LookAtWithStyle_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hri_actions_msgs::msg::LookAtWithStyle_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hri_actions_msgs::msg::LookAtWithStyle_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hri_actions_msgs::msg::LookAtWithStyle_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hri_actions_msgs::msg::LookAtWithStyle_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hri_actions_msgs__msg__LookAtWithStyle
    std::shared_ptr<hri_actions_msgs::msg::LookAtWithStyle_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hri_actions_msgs__msg__LookAtWithStyle
    std::shared_ptr<hri_actions_msgs::msg::LookAtWithStyle_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LookAtWithStyle_ & other) const
  {
    if (this->style != other.style) {
      return false;
    }
    if (this->target != other.target) {
      return false;
    }
    return true;
  }
  bool operator!=(const LookAtWithStyle_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LookAtWithStyle_

// alias to use template instance with default allocator
using LookAtWithStyle =
  hri_actions_msgs::msg::LookAtWithStyle_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t LookAtWithStyle_<ContainerAllocator>::DEFAULT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t LookAtWithStyle_<ContainerAllocator>::EYES_ONLY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t LookAtWithStyle_<ContainerAllocator>::HEAD_ONLY;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hri_actions_msgs

#endif  // HRI_ACTIONS_MSGS__MSG__DETAIL__LOOK_AT_WITH_STYLE__STRUCT_HPP_
